function [ estry EstVar ] = npryvar( Fs, x1axis, x2axis )
 
	Gx1 = length( x1axis );
	Gx2 = length( x2axis );

    d1 = range( x1axis ) / Gx1 ;
    d2 = range( x2axis ) / Gx2 ;
     
    Fs.weight = Fs.weight / (d1 * d2 * sum(sum(Fs.weight)));
	
    gy1 = d1 * d2 * sum( sum( Fs.dfY_Xdy1 ./ Fs.fY_X .*  Fs.weight ) );
	gy2 = d1 * d2 * sum( sum( Fs.dfY_Xdy2 ./ Fs.fY_X .*  Fs.weight ) );
	gx1 = d1 * d2 * sum( sum( Fs.dfY_Xdx1 ./ Fs.fY_X .*  Fs.weight ) );
	gx2 = d1 * d2 * sum( sum( Fs.dfY_Xdx2 ./ Fs.fY_X .*  Fs.weight ) );
                            
    Ty11 = (  Fs.dfY_Xdy1 ./ Fs.fY_X - gy1 ) .* ...
	       (  Fs.dfY_Xdx1 ./ Fs.fY_X - gx1 ) ;
	Ty12 = (  Fs.dfY_Xdy1 ./ Fs.fY_X - gy1 ) .* ...
	       (  Fs.dfY_Xdx2 ./ Fs.fY_X - gx2 ) ;
	Ty21 = (  Fs.dfY_Xdy2 ./ Fs.fY_X - gy2 ) .* ...
	       (  Fs.dfY_Xdx1 ./ Fs.fY_X - gx1 ) ;
	Ty22 = (  Fs.dfY_Xdy2 ./ Fs.fY_X - gy2 ) .* ...
	       (  Fs.dfY_Xdx2 ./ Fs.fY_X - gx2 ) ;
	Tx11 = (  Fs.dfY_Xdx1 ./ Fs.fY_X - gx1 ) .* ...
	       (  Fs.dfY_Xdx1 ./ Fs.fY_X - gx1 ) ;
	Tx12 = (  Fs.dfY_Xdx1 ./ Fs.fY_X - gx1 ) .* ...
	       (  Fs.dfY_Xdx2 ./ Fs.fY_X - gx2 ) ;
	Tx22 = (  Fs.dfY_Xdx2 ./ Fs.fY_X - gx2 ) .* ...
	       (  Fs.dfY_Xdx2 ./ Fs.fY_X - gx2 ) ;
                
   	Ga = d1 * d2 * [ sum( sum( Ty11 .* Fs.weight ) )   ...
		             sum( sum( Ty21 .* Fs.weight ) ) ; ...
			         sum( sum( Ty12 .* Fs.weight ) )   ...
			         sum( sum( Ty22 .* Fs.weight ) ) ];
       
	Pi = d1 * d2 * [ sum( sum( Tx11 .* Fs.weight ) )   ...
			         sum( sum( Tx12 .* Fs.weight ) ) ; ...
			         sum( sum( Tx12 .* Fs.weight ) )   ...
			         sum( sum( Tx22 .* Fs.weight ) ) ];
    	
    Vy11 = d1 * d2 * sum( sum(  Tx11  .* (Fs.weight.^2) ./  Fs.fYX ) ) ;
	Vy12 = d1 * d2 * sum( sum(  Tx12  .* (Fs.weight.^2) ./  Fs.fYX ) ) ;
	Vy22 = d1 * d2 * sum( sum(  Tx22  .* (Fs.weight.^2) ./  Fs.fYX ) ) ;
			
	Vy     = kron( kernelconst, [ Vy11 Vy12; Vy12 Vy22 ] );
			 
    KIPinv = inv( kron( eye( 2 ), Pi ) );
	
    EstVar      = KIPinv * Vy * KIPinv;
	estry       = inv( Pi ) * Ga;
    
end








