function [ Fs ] = kernelest_oneinst( Y, X, AXES, WAXES, bw, THRESH )
	YX = [ Y X ];
	
	 naxes = length( AXES );

	f3     = zeros( naxes, 1 );
	f1     = zeros( naxes, 1 );
	df3dy1 = zeros( naxes, 1 );
	df3dy2 = zeros( naxes, 1 );
	df3dx = zeros( naxes, 1 );
	df1dx = zeros( naxes, 1 );

	for ( i = 1 : naxes )
	axisbb = AXES(i,:); 

       f1(i)      = joint( X , axisbb(:,3),bw.fX     );
       f3(i)      = joint( YX, axisbb     ,bw.fYX    );      
       df3dy1(i)  = djoint(YX, axisbb     ,bw.dfYXdy1, 1);  
       df3dy2(i)  = djoint(YX, axisbb     ,bw.dfYXdy2, 2);  
       df3dx(i)   = djoint(YX, axisbb     ,bw.dfYXdx2, 3);  
       df1dx(i)   = djoint(X , axisbb(:,3),bw.dfXdx2 , 1);  
    end

	fcond  = f3 ./ f1;
	dfdy1  = df3dy1 ./ f1;
	dfdy2  = df3dy2 ./ f1;
	dfdx   = df3dx  ./ f1 - df1dx .* f3 ./ f1 .^ 2;
     
    dlogfy_xdy1 = dfdy1 ./ fcond ;
    dlogfy_xdy2 = dfdy2 ./ fcond ;
    dlogfy_xdx  = dfdx  ./ fcond ;

	ZeroWeight =  ( f3 > THRESH & f1 > THRESH & fcond > THRESH ) .* WAXES;
	 
    Fs      = struct(                   ...
		'fyx',     f3 ,        ...
		'fy_x',      fcond ,     ...
		'fx',        f1 ,        ...
		'dfyxdx',   df3dx ,    ...
		'dfy_xdx',  dfdx ,     ...
		'dfyxdy1',   df3dy1 ,    ...
		'dfy_xdy1',  dfdy1 ,     ...
		'dfyxdy2',   df3dy2 ,    ...
		'dfy_xdy2',  dfdy2 ,     ...
		'dfxdx',    df1dx ,    ...
		'dlogfy_xdy1', dlogfy_xdy1 ,    ...
		'dlogfy_xdy2', dlogfy_xdy2 ,    ...
		'dlogfy_xdx', dlogfy_xdx ,    ...
		'ZeroWeight',    ZeroWeight );

end






