function [ npest Varest diff ] = npryvar_oneinst( Fs, xaxis )
    
    Gx   = length(xaxis);
     
    d      = range(xaxis) / Gx;
    
    weight = Fs.ZeroWeight / (d * sum(Fs.ZeroWeight));
	
    one = ones([Gx 1]);
   
            gy1 = d * sum( Fs.dlogfy_xdy1 .*  weight ) ;
            gy2 = d * sum( Fs.dlogfy_xdy2 .*  weight ) ;
            gp  = d * sum( Fs.dlogfy_xdx  .*  weight ) ;

    
            diffy1 = ( Fs.dlogfy_xdy1  - gy1 * one) ;
            diffy2 = ( Fs.dlogfy_xdy2  - gy2 * one) ;
            diffx  = ( Fs.dlogfy_xdx   - gp  * one) ;
           
             
            VTxx =    diffx  .* diffx ;
            VTy1x =   diffy1 .* diffx ;
            VTy2x =   diffy2 .* diffx;
            VTy1y1 =  diffy1 .* diffy1 ;
            VTy2y2 =  diffy2 .* diffy2 ;
            VTy1y2 =  diffy1 .* diffy2 ;
              
            
                             
            Ty1x =  d * sum( VTy1x .* weight );
            Ty2x =  d * sum( VTy2x .* weight );
                 
            Ty1y1 = d * sum( VTy1y1 .* weight );
            Ty2y2 = d * sum( VTy2y2 .* weight );
            Ty1y2 = d * sum( VTy1y2 .* weight );
            Txx   = d * sum( VTxx   .* weight );
              
  % calculate estimator
     
           numest    = Ty1y2 * Txx - Ty2x * Ty1x ;
           denomest  = Ty1y1 * Txx - Ty1x * Ty1x ;
            
           npest    = - numest / denomest ;
 
  
 % calculate variance
    
        omegay1  = ((( diffy2 * Txx - diffx  * Ty2x )     / denomest ) ...
                 -  (( diffy1 * Txx - diffx  * Ty1x )* 2 * numest / denomest^2)  ) ...
                 .* weight ./ Fs.fyx ;
              
        omegay2  =  ((diffy1 * Txx - diffx * Ty1x) / denomest ) .* weight ./ Fs.fyx ;
        
        Omegamatrix  = [( d * sum( omegay1 .* omegay1 .* Fs.fyx))  (d * sum( omegay1 .* omegay2 .* Fs.fyx) );  ...
                        ( d * sum( omegay1 .* omegay2 .* Fs.fyx))  (d * sum( omegay2 .* omegay2 .* Fs.fyx) )]; 
                 
        dKmatrix     = kernelconst;
         
        Varest = Omegamatrix(1,1) * dKmatrix(1,1) + 2 * Omegamatrix(1,2)* dKmatrix(1,2) + Omegamatrix(2,2) * dKmatrix(2,2) ;
  
        diff = struct(  ... 
               'diffy1', diffy1, ...
               'diffy2', diffy2, ...
               'diffx', diffx, ...
               'VTxx', VTxx, ...
               'VTy1x', VTy1x, ...
               'VTy2x', VTy2x, ...
               'VTy1y1', VTy1y1, ...
               'VTy1y2', VTy1y2, ...
               'VTy2y2', VTy2y2, ...
               'Txx', Txx, ...
               'Ty1x', Ty1x, ...
               'Ty2x', Ty2x, ...
               'Ty1y1', Ty1y1, ...
               'Ty1y2', Ty1y2, ...
                'Ty2y2', Ty2y2, ...
                'numest', numest, ...
                'denomest', denomest, ...
                'omegay1', omegay1, ...
                'omegay2', omegay2, ...
                'Omegamatrix', Omegamatrix, ...
                'Varest', Varest ...
                );
           
	end






