
function [ starmatrix est varmatrix eststdmatrix denombd] = estimate( data, y, bands, order, constest )
	 
    N     = size( data, 1 );
  
% * define funcitons to obtain estimates of the relevant functions over all values of x
 
	f3        =  @( x ) djoint( data - repmat( [ y x ], [ N 1 ] ), bands.fYX,    [ 0 0 0 ], order);
    f1        =  @( x ) djoint( data(:,3) - repmat( x , [ N 1 ] ), bands.fX,          0  , order);
    df3dx     =  @( x ) djoint( data - repmat( [ y x ], [ N 1 ] ), bands.dfYXdx, [ 0 0 1 ], order);
    df1dx     =  @( x ) djoint( data(:,3) - repmat( x , [ N 1 ] ), bands.dfXdx,       1  , order);
    
    DLx       = @( x ) (df3dx(x)./f3(x) - df1dx(x)./f1(x)) ;    %       DLx=dlogy_xdx 
     
      
  % set upper and lower bounds for the values of x where to search
  
    lbx       = quantile(data(:,3),.05);
    ubx       = quantile(data(:,3),.95);
   
    % set parameters for grid search
     
    sizesparsegrid       = 1500;
    sizedensegrid        = 500;
    sparsegrid           = linspace( lbx, ubx, sizesparsegrid );
    densegrid            = [];
        
        for i=1:length(sparsegrid)
            DLxsparse(i) = DLx(sparsegrid(i));
        end
        
        for i=1:(length(sparsegrid)-1)
           if  ( DLxsparse(i) * DLxsparse(i+1) < 0) 
                addgrid   = linspace(sparsegrid(i), sparsegrid(i+1), sizedensegrid);
                densegrid = [ densegrid addgrid ];
           end
        end
        
            grid = densegrid ;
            Lgrid = length(grid);

% find stars
  
    for i=1:Lgrid
         DLxgrid(i)    = DLx(grid(i));
    end

    ZeroDLx = find( DLxgrid(1:Lgrid-1) .* DLxgrid(2:Lgrid) < 0 );
     
    possiblestars = grid(ZeroDLx);
    
    AXES = [repmat(y,[length(possiblestars),1]) possiblestars'];
  
    dlogs = estimate_dlogs(data, AXES, order, bands);

    [ starmatrix est varmatrix eststdmatrix denombd sol] = npvar_ind(possiblestars, dlogs, bands, order, constest, N);
     
    if (sol == 0)
        starmatrix       = 0;
        est              = 0;
        varmatrix        = 0;
        denombd          = 0;
    end;
         
end

