clc;
close all;
clear al

DGP_LINEAR = 1;          
DGP_NONLIN = 2;          

dgp        = DGP_NONLIN;    % set dgp though this variable 
    
    if     ( dgp == DGP_LINEAR )
	         dgpcode   = 'LINEAR';
             truebeta  = .75;
    elseif ( dgp == DGP_NONLIN )
	         dgpcode   = 'NONLIN';
             truebeta  = -5.;
    else
	        error( 'Bad DGP specified; must be LINEAR or NONLIN.' );
    end

    S = 500;
	N = 25000;
    
    necess = S * N;
 
    filename = sprintf( 'data_%s.mat', dgpcode );
 
if  ( exist( filename ))
	load( filename );
    fprintf( 'Loading data ... \n' );
    if ( size( YY, 1 ) < necess )
	fprintf( 'Data in file is insufficient ... \n' );
    break;
    end
else
    fprintf( 'Generate data using gendata ... \n' );
end
    
    data        = [YY PP];
	order       =  4; 
    THRESHdenom =  1e-6;

    Ind     = zeros([S,1]);
    estbeta = zeros([S,1]);
    eststd  = zeros([S,1]);
 
    countdata = 0;
 
    for s=1:S 
       
        dataS     = data(countdata+1:countdata+N,:);
         
    % standarize the data
      
        sigdata = std(dataS);
     
        dataSstd = (dataS - repmat(mean(dataS),[N,1])) ./ repmat(sigdata,[N,1]);
    
        constest = sigdata(1)/sigdata(2);
    
        countdata  = countdata + N;
        
     %  specify point at which estimation takes place
      
        if     ( isequal( dgp, DGP_LINEAR ) )
	             ypoints = ( [0 0] - [mean(dataS(:,1)) mean(dataS(:,2))]) ./ [sigdata(1) sigdata(2)];
        elseif ( isequal( dgp, DGP_NONLIN' ) )
        		 ypoints = ( [5 5] - [mean(dataS(:,1)) mean(dataS(:,2))])./ [sigdata(1) sigdata(2)] ;
        end
	
  
      % bandwidths

        N3d0 =  .75 * N ^ ( -1 / ( 3 + 2 * order ) );                  
        N3d1 =  .75 * N ^ ( -1 / ( 3 + 2 * order + 2 ) );
        N3d2 =  .75 * N ^ ( -1 / ( 3 + 2 * order + 4 ) );
        N1d0 =  .75 * N ^ ( -1 / ( 1 + 2 * order ) );                  
        N1d1 =  .75 * N ^ ( -1 / ( 1 + 2 * order + 2 ) );
        N1d2 =  .75 * N ^ ( -1 / ( 1 + 2 * order + 4 ) );

        sigband = std(dataSstd);
 
        bands = struct(            ...
                'fYX',       sigband * N3d0, ...
                'fX',        sigband(3) * N1d0 , ...
                ...
                'dfYXdy1',   sigband * N3d1, ...
                'dfYXdy2',   sigband * N3d1, ...
                'dfYXdx',    sigband * N3d1, ...
                ...
                'dfXdx',     sigband(3) * N1d1, ...
                ...
                'dfYXdy1dx', sigband * N3d2, ...
                'dfYXdy2dx', sigband * N3d2, ...
             	'dfYXdxdx',  sigband * N3d2, ...
                 ...
                'dfXdxdx',  sigband(3) * N1d2 ...
                  );

     %  estimate
 
[ starmatrix est varmatrix eststdmatrix denombd] = estimate(dataSstd, ypoints, bands, order, constest);

    [j k ] = size(varmatrix);
      
        if ( (k>1) && ((est(1,k)*truebeta) >0 ) && (denombd(1,k)>THRESHdenom))  
  
            estbeta(s)     = est(1,k);
            eststd(s)      = eststdmatrix(1,k);
            Ind(s)         = 1;

        end
     
    end
    
 I = find(Ind>0);
 
 cover95 = sum((abs(truebeta*ones([sum(Ind),1])-estbeta(I))<1.96 * eststd(I)))/sum(Ind);
  
 meanest    = mean(estbeta(I));
 stdest     = std(estbeta(I));
 meaneststd = mean(eststd(I));
 