function [ starmatrix est varmatrix eststdmatrix denombd sol] = npvar_ind(possiblestars, dlogs, bands, order, constest, N)
 
L = length(possiblestars);
sol = 0;

if (L>1)
    
for j=1:L;
    starmatrix(j,j) = possiblestars(j);
    for h=j+1:L
           
    % calculate the denomominators of estimator and variance 
   
    Diffy1 = dlogs.dy1(h) - dlogs.dy1(j);
    
    ddy1_j = dlogs.dy1(j) * dlogs.f3(j);
    ddy1_h = dlogs.dy1(h) * dlogs.f3(h);
    ddy2_j = dlogs.dy2(j) * dlogs.f3(j);
    ddy2_h = dlogs.dy2(h) * dlogs.f3(h);
	
	denomomega11 =  ( ddy1_j * dlogs.f3(h) - ddy1_h * dlogs.f3(j)) ^ 2;
    denomomega12 =  ( ddy1_j * dlogs.f3(h) - ddy1_h * dlogs.f3(j) );
    denomomega13 =  ( dlogs.dxdx(j) * dlogs.f3(j) );
	denomomega23 =  ( dlogs.dxdx(h) * dlogs.f3(h) );
                 
               
    starmatrix(j,h) = possiblestars(h);
           
    est(j,h)        = (dlogs.dy2(j) - dlogs.dy2(h)) / Diffy1 * constest ;
            
    denombd(j,h)      = min([abs(denomomega11) abs(denomomega12) abs(denomomega13) abs(denomomega23) abs(Diffy1)]);
                 
    sol               = 1;
     
    % estimate variance
     
  	omega11 = -( ddy2_h * dlogs.f3(j) - ddy2_j * dlogs.f3(h) ) * dlogs.f3(h) ...
	         / denomomega11;
 
    omega12 = -dlogs.f3(h) / denomomega12 ;
     
    omega13 = -( - dlogs.dy2dx(j) / ( dlogs.dy1(j) - dlogs.dy1(h) ) - ...
	         (  dlogs.dy2(h) - dlogs.dy2(j) ) * dlogs.dy1dx(j) /   ...
	         ( dlogs.dy1(j) - dlogs.dy1(h) ) ^ 2 )                    ...
	         / denomomega13;
	
	
	omega21 = ( ddy2_h * dlogs.f3(j) - ddy2_j * dlogs.f3(h) ) * dlogs.f3(j) ...
	         / denomomega11;
	 
    omega22 = dlogs.f3(j) / denomomega12;
    
    omega23 = - ( dlogs.dy2dx(h) / ( dlogs.dy1(j) - dlogs.dy1(h) ) + ...
	         ( dlogs.dy2(h) - dlogs.dy2(j) ) * dlogs.dy1dx(h) /   ...
	         ( dlogs.dy1(j) - dlogs.dy1(h) ) ^ 2 )                    ...
	         / denomomega23;
	
	omega1 = [ omega11 omega12 omega13 ];

    omega2 = [ omega21 omega22 omega23 ];

    K      = kernelconst3dim(order);
    
    
    varmatrix(j,h)      = (omega1 * K * omega1' * dlogs.f3(j) + omega2 * K * omega2' * dlogs.f3(h)) * constest^2;
                 
                 b      = bands.dfYXdy1(1)^2 * bands.dfYXdy2(2)^2 * bands.dfYXdx(3);
  
    eststdmatrix(j,h)   = sqrt(varmatrix(j,h)/N/b) ;
     
    end
end
  
else
    starmatrix   = 0;
    est          = 0;
    varmatrix    = 0;
    denombd      = 0;
    eststdmatrix = 0;
end
end

 
